#version 420 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;


out vec2 TexCoord;


// Output data ; will be interpolated for each fragment.
out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;
out vec3 LightDirection_cameraspace;

out vec3 position_cameraspace;
out vec3 normal_cameraspace;
out vec4 screenPos;


//Matrices
uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

uniform mat4 ModelViewProjection;
uniform mat4 ModelView;


//these matrices require inverse operation which is expensive when performed per vertex or worse, fragment
uniform mat3 NormalMatrix;
uniform mat4 InverseView;

uniform vec3 LightPosition_worldspace;
uniform vec4 LightColor;
//uniform float LightPower;

//from: http://antongerdelan.net/opengl/cubemaps.html

invariant gl_Position;

void main()
{
	//LightPosition_worldspace = MVP * vec4(LightPosition_worldspace,1.0f).rgb;
	//vec3 LightPosition_normalized = normalize(LightPosition_worldspace);
	
	TexCoord = texCoords;

/*
	position_cameraspace	= vec3(ModelView * vec4(position, 1.0));
  	normal_cameraspace		= vec3(ModelView * vec4(normal, 0.0));
*/
	screenPos = ModelViewProjection * vec4(position, 1.0);

  	gl_Position = screenPos;

} 

