#version 330 core

in vec2 TexCoord;
in vec3 Position_cameraspace;
in vec3 Normal_cameraspace;
in vec4 screenPos;


out vec4 color;

//texture assigned to water
uniform sampler2D _textureSampler;


//rendered scene for refraction, etc
uniform sampler2D renderedTexture;

uniform sampler2D _normalSampler;

uniform sampler2D _refractSceneTexture;

uniform sampler2D _underWaterTexture;


uniform mat4 InverseView; 
//uniform float time;

const float bumpScale = 0.6;

void main(){

	
/*
	vec3 incident_eye	= normalize(Position_cameraspace);
  	vec3 normal			= normalize(Normal_cameraspace);
  	vec3 reflected		= reflect(incident_eye, normal);
	
	float ratio = 1.0 / 1.3;
	vec3 refracted = refract(incident_eye, normal, ratio);



	reflected = vec3(InverseView * vec4(reflected, 0.0));
	refracted = vec3(InverseView * vec4(refracted, 0.0));


	
	vec4 bumpTex = 2.0 * texture(_normalSampler, TexCoord) - 1.0;
	vec3 TextureColor = texture( _textureSampler, TexCoord).xyz;
	TextureColor = vec3(TextureColor.x, TextureColor.y, 0.) * 0.1;


	//vec2 screenUV = (screenPos.xy / 1.) + bumpTex.xy * bumpScale;// + normal.xy / 2.;
	vec2 screenUVFlipped = vec2(screenPos.x / screenPos.w, -screenPos.y / screenPos.w) + bumpTex.xy * ratio; 
*/
	float ratio = 1.0 / 1.3;
	vec4 colTemp;
	vec4 bumpTex = 2.0 * texture(_normalSampler, TexCoord) - 1.0;

	vec2 screenUV  = refract(
		vec3(screenPos.x, 0.5-screenPos.y, screenPos.z)
	, bumpTex.xyz, ratio).xy;


	//screenspace refraction
	vec4 color1 = texture(_refractSceneTexture, screenUV) * 0.1;

	//my fake water refraction because i couldn't get the perspective right
	vec4 color2 = texture(_underWaterTexture, screenUV) * 0.65;

	vec4 color3 = vec4(0.94,1.,1.,1.); //azure

	//colTemp = texture(_refractSceneTexture, refracted.xy); 
	//colTemp = texture(_refractSceneTexture, refracted.xy) * 0.9; 
	//colTemp = texture(_refractSceneTexture, screenUV) * 0.1;					//refractive part.
	//colTemp = texture(_underWaterTexture, screenUV) * 0.65;
	//colTemp = colTemp + texture(_refractSceneTexture, screenUVFlipped) * 0.25; // reflective part
	//colTemp = colTemp + vec4(TextureColor,.1);
	//colTemp = colTemp + vec4(0.125,0.2,0.25,0.1);
	
	color = mix(color1, color2, color2.w);
	//color = mix(color, color3, color.w);
	//color = texture( _textureSampler, TexCoord);
	//color = vec4(screenPos.x, -screenPos.y, screenPos.zw);
	//color = texture(_refractSceneTexture, (screenPos.xy ));
	//color = bumpTex;
}