#version 330 core
in vec4 FragPos;

uniform vec3 LightPosition_worldspace;
uniform float far_plane;
#define BIAS 0.0019

void main()
{
    float lightDistance = distance(FragPos.xyz,LightPosition_worldspace);
    
    // map to [0;1] range by dividing by far_plane
    lightDistance = lightDistance / far_plane;
    
    // write this as modified depth
    gl_FragDepth = lightDistance;
	gl_FragDepth += gl_FrontFacing ? BIAS : 0.0; 
}